
//////////////////////////////////////////////////////
//													//
// Display Picture Changer v 1.3		13/04/2007	//
// .NET Developer For Rent							//
// http://www.dotnetdeveloperforrent.be				//
//													//
// Credits to James Lambeths						//
// I created this script starting from his			//
// 'Random DP' script, made some changes to it		//
// and added more functionality.					//
// You can find his script here:					//
// http://www.cryptix.info/randdp					//
//													//
//////////////////////////////////////////////////////

//Plugin options
var DpPath, subdirs, aLogin, aTimer, timerL, random, shuffle;
//Other variables
var displayPics;
var scriptTitle = "Display Picture Changer";
var devName = ".NET Developer For Rent";
var versionFile = "http://www.verschuere.be/DPC/version.txt";
var downloadLocation = "http://www.msgpluslive.net/scripts/view/77-Display-Picture-Changer/";
var scriptVersionMajor = 1;
var scriptVersionMinor = 3;
//index of next picture
var picIndex = 0;
var currentPicIndex = 0;
//ActiveX Stuff
var WScript = new ActiveXObject("WScript.Shell");
var winShell = new ActiveXObject("Shell.Application");
var fsoObj = new ActiveXObject("Scripting.FileSystemObject");

////////////////
// Initialize //
////////////////
function OnEvent_Initialize(MessengerStart)
{
	if (!MessengerStart)
	{
		initialize();
	}
	else
	{
	    //on messengerstartup check for update
	    checkUpdate(false);
	}
}

/////////////
// Sign In //
/////////////
function OnEvent_Signin(Email)
{	
	initialize();
}

////////////////////////////
// Option control Clicked //
////////////////////////////
function OnDPCOptionsEvent_CtrlClicked(PlusWnd, ControlId)
{
	switch (ControlId)
	{
		case "BtnOk":
			optionsOKClicked(PlusWnd);
			break;
		case "BtnBrowse":
			optionsBrowseClicked(PlusWnd);
			break;
	}
}

//////////////////////////////
// Option button OK Clicked //
//////////////////////////////
function optionsOKClicked(PlusWnd)
{
	DpPath = PlusWnd.GetControlText('EdtDpDir');
	subdirs = PlusWnd.Button_IsChecked('CkIncludeSubDir');
	//strip leading spaces
	while(DpPath.indexOf(' ') == 0)
	{
		DpPath = DpPath.substr(1);
	}
	aLogin = PlusWnd.Button_IsChecked('CkAutoLogin');
	aTimer = PlusWnd.Button_IsChecked('CkAutoRotate');
	if (isNaN(PlusWnd.GetControlText('EdtRTime')))
	{
		timerL = 60000;
	}
	else
	{
		timerL = PlusWnd.GetControlText('EdtRTime') * 1000;
	}
	random = PlusWnd.Button_IsChecked('RadRandom');
	shuffle = PlusWnd.Button_IsChecked('CkShuffle');
	if(Messenger.MyEmail != "")
	{
		SaveSettings(Messenger.MyEmail);
	}
	populateDp();
	if(aTimer)
	{	
		ChangeDp();	
	}
	PlusWnd.Close(1);
}

//////////////////////////////////
// Option button browse Clicked //
//////////////////////////////////
function optionsBrowseClicked(PlusWnd)
{
	PlusWnd.SetControlText('EdtDpDir', browseFolderDialog());
}

function OnGetScriptMenu(Location)
{
	if (Location == 1)
	{
        return '<ScriptMenu><MenuEntry Id="Options">Options</MenuEntry><MenuEntry Id="Change">Change Picture</MenuEntry><MenuEntry Id="Delete">Delete Current Display Picture</MenuEntry><MenuEntry Id="Reload">Reload Display Picture List</MenuEntry><MenuEntry Id="StartRotate">Start Rotation</MenuEntry><MenuEntry Id="StopRotate">Stop Rotation</MenuEntry><Separator/><MenuEntry Id="About">About...</MenuEntry><MenuEntry Id="CheckUpdate">Check For New Version</MenuEntry></ScriptMenu>';
    }
    else
    {
        return '';
    }
}

//////////////////
// Menu Clicked //
//////////////////
function OnEvent_MenuClicked(MenuItemId, Location, OriginWnd)
{
	switch (MenuItemId)
	{
		case "Options":
			displayOptions();
			break;
		case "Change":
			ChangeDp();
			break;
		case "Steal":
			if (Location == 2)
			{
				StealDp(OriginWnd);
			}
			else
			{
				MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Call this function from the chatwindow of the contact you wish to steal the display picture from.", "", "");
			}
			break;
		case "Delete":
			DeleteDp();
			break;
		case "Reload":
			reloadDpList();
			break;
		case "StartRotate":
			rotationStart();
			break;
		case "StopRotate":
			rotationStop();
			break;
		case "About":
			displayAbout();	
			break;
		case "CheckUpdate":
		    checkUpdate(true);
		    break;
	}
}

///////////////////////////
// About Control Clicked //
///////////////////////////
function OnWndAboutEvent_CtrlClicked(PlusWnd, ControlId)
{	
	switch (ControlId)
	{
		case "gotowebsite":
			WScript.run("http://www.dotnetdeveloperforrent.be");
			PlusWnd.Close(1);
			break;
		case "lblOptions":
			displayOptions();
			PlusWnd.Close(1);
			break;
		case "lblChange":
			ChangeDp();
			break;
		case "lblDelete":
			DeleteDp();
			break;
		case "lblReload":
			reloadDpList();
			break;
		case "lblRotateStart":
			rotationStart();
			break;	
		case "lblRotateStop":
			rotationStop();
			break;
		case "lblCheckUpdate":
		    checkUpdate(true);
		    break;
	}
}

//////////////
// Commands //
//////////////
function OnEvent_ChatWndSendMessage(ChatWnd, Message)
{
	var m = Message.toLowerCase();
	switch (m)
	{
		case "/dpcoptions":
			displayOptions();
			return "";
		case "/dpcchange":
			ChangeDp();
			return "";
		case "/dpcsteal":
			StealDp(ChatWnd);
			return "";
		case "/dpcdelete":
			DeleteDp();
			return "";
		case "/dpcreload":
			reloadDpList();
			return "";
		case "/dpcrotatestart":
			rotationStart();
			return "";
		case "/dpcrotatestop":
			rotationStop();
			return "";	
		case "/dpcabout":
			displayAbout();	
			return "";
		case "/dpccheckupdate":
		    checkUpdate(true);
		    return "";
		case "/dpcstealsilent":
			//not documented
			StealDpSilent(ChatWnd);	
			return "";
	}
	return Message;
}

////////////////////
// start rotation //
////////////////////
function rotationStart()
{
	if (!aTimer)
	{
		aTimer = true;
		ChangeDp();
	}
}

////////////////////
// stop rotation //
////////////////////
function rotationStop()
{
	aTimer = false;
	stopTimer();
}

////////////////
// initialize //
////////////////
function initialize()
{	
	if(Messenger.MyEmail != "")
	{	
		GetSettings(Messenger.MyEmail);
		populateDp();
		if( aLogin )
		{	
			ChangeDp();	
		}
		else if (aTimer)
		{
			startTimer();
		}
	}
	else
	{
		initOptions();
	}
}

///////////////////////////////
// Initialize plugin options //
///////////////////////////////
function initOptions()
{
	DpPath = WScript.SpecialFolders("MyDocuments");
	if (DpPath == null || DpPath == '')
	{
		DpPath = "C:\\";
	}
	subdirs = false;
	aLogin = true;
	aTimer = true;
	timerL = 60000;
	random = false;
	shuffle = true;
	displayPics = new Array();
}

////////////////////////////////////
// Steal Display picture Silently //
// (Undocumented)				  //
////////////////////////////////////
function StealDpSilent(ChatWnd)
{
	var contact = (new Enumerator(ChatWnd.Contacts)).item();
	var dp = contact.DisplayPicture;
	if (dp != "")
	{
		if(fsoObj.FileExists(dp))
		{
			var baseName = fsoObj.GetBaseName(dp);
			var ext = fsoObj.GetExtensionName(dp);
			if (ext == "")
			{
				ext = "png";
			}
			var newPath = fsoObj.BuildPath(DpPath, baseName + "." + ext);
			var count = 1;
			while (fsoObj.FileExists(newPath))
			{
				newPath = fsoObj.BuildPath(DpPath, baseName + "[" + count + "]." + ext);
				count++;
			}
			fsoObj.CopyFile(dp, newPath);
			MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Display Picture stolen silently!", "", "");
		}
	}
	else
	{
		MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Contact has no display picture", "", "");
	}
}

///////////////////////////
// Steal Display picture //
///////////////////////////
function StealDp(ChatWnd)
{
	//stop timer to not interrupt functionality
	stopTimer();
	var contact = (new Enumerator(ChatWnd.Contacts)).item();
	var dp = contact.DisplayPicture;
	if (dp != "")
	{
		if(fsoObj.FileExists(dp))
		{
			var baseName = fsoObj.GetBaseName(dp);
			var ext = fsoObj.GetExtensionName(dp);
			if (ext == "")
			{
				ext = "png";
			}
			var newPath = fsoObj.BuildPath(DpPath, baseName + "." + ext);
			var count = 1;
			while (fsoObj.FileExists(newPath))
			{
				newPath = fsoObj.BuildPath(DpPath, baseName + "[" + count + "]." + ext);
				count++;
			}
			fsoObj.CopyFile(dp, newPath);
			currentPicIndex = displayPics.length;
			picIndex = 0;
			displayPics[currentPicIndex] = newPath;
			Messenger.MyDisplayPicture = newPath;
			var chat = Messenger.OpenChat(contact.Email);
			if (chat != null && chat.EditChangeAllowed)
			{
				chat.SendMessage("/me has stolen (!N)'s Display Picture! (6)\n\n[b]'" + scriptTitle + "'[/b]\n(-- " + devName + " --)\n\n");
			}
			MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Display Picture stolen!", "", "");
		}
	}
	else
	{
		MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Contact has no display picture", "", "");
	}
	//restart timer
	if (aTimer)
	{
		startTimer();
	}
}

////////////////////////////
// Delete Display picture //
////////////////////////////
function DeleteDp()
{
	//stop timer to not interrupt functionality
	stopTimer();
	var retVal = WScript.Popup("Current display picture will be removed from the list!\nDo you also want to remove the display picture from the filesystem?", 60, "Delete Display Picture", 4+32);
	var tmp = displayPics.splice(currentPicIndex,1);
	ChangeDp();
	MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Display Picture removed from list", "", "");
	if (retVal == 6)
	{
		if(fsoObj.FolderExists(DpPath))
		{	
			var dir = fsoObj.GetFolder(DpPath);
			fsoObj.DeleteFile(tmp[0], true);
			MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Display Picture removed from filesystem", "", "");		
		}
	}
}

////////////////////////////
// Change Display Picture //
////////////////////////////
function ChangeDp()
{
	stopTimer();
	if(displayPics != "" && displayPics.length > 0)
	{
		if (random)
		{
			currentPicIndex = Math.floor(Math.random()*displayPics.length);
			fileName =  displayPics[currentPicIndex];
		}
		else
		{
			currentPicIndex = picIndex;
			fileName = displayPics[currentPicIndex];
			picIndex++;
			if (picIndex >= displayPics.length)
			{
				picIndex = 0;
			}
		}
		try
		{
			if (fsoObj.FileExists(fileName))
			{
    			Messenger.MyDisplayPicture = fileName;
    		}
    	}
    	catch(exception){}
		//restart timer
		if (aTimer)
		{
			startTimer();
		}
	}
	else
	{
		MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "No pictures in current folder", "", "displayOptions");	
	}
}

//////////////////////////
// Browse Folder Dialog //
//////////////////////////
function browseFolderDialog()
{
	var folder = winShell.BrowseForFolder(0, "Select the directory containing your display pictures. No other pictures should be contained with this directory.", 0, 0);
	var fPath = "";
	if (folder != null)
	{
		if (folder.Items() != null)
		{
			if (folder.Items().Item() != null)
			{
				fPath = folder.Items().Item().Path;
			}
		}
	}
	if (fPath == "")
	{
		fPath = DpPath;
	}
	return fPath;
}

////////////////////////////
// Display Options Window //
////////////////////////////
function displayOptions()
{	
	plusWnd = MsgPlus.CreateWnd('windows.xml', 'DPCOptions');		
	plusWnd.SetControlText('EdtDpDir', DpPath);
	plusWnd.Button_SetCheckState('CkIncludeSubDir', subdirs);
	plusWnd.Button_SetCheckState('CkAutoLogin', aLogin);
	plusWnd.Button_SetCheckState('CkAutoRotate', aTimer);
	plusWnd.SetControlText('EdtRTime', (timerL / 1000));
	plusWnd.Button_SetCheckState('RadRandom', random);
	plusWnd.Button_SetCheckState('RadSlide', !random);
	plusWnd.Button_SetCheckState('CkShuffle', shuffle);
}

////////////////////////////
// Display About Window //
////////////////////////////
function displayAbout()
{	
	MsgPlus.CreateWnd('about.xml', 'WndAbout');
}

/////////////////////////////////////
// Reload Display Pictures Array //
/////////////////////////////////////
function reloadDpList()
{
	populateDp();
	currentPicIndex = 0;
	picIndex = 0;
	ChangeDp();
}

/////////////////////////////////////
// Populate Display Pictures Array //
/////////////////////////////////////
function populateDp()
{		
	if(fsoObj.FolderExists(DpPath))
	{	
	    displayPics = new Array();
	    dirs = new Array();
	    Dir = fsoObj.GetFolder(DpPath);
	    dirs[dirs.length] = Dir;
	    CollSubDirs = new Enumerator(Dir.SubFolders);
        for (;!CollSubDirs.atEnd(); CollSubDirs.moveNext())
        {
            dirs[dirs.length] = CollSubDirs.item();
        }
        var i;
        for(i=0; i < dirs.length; i++)
        {
		    Files = new Enumerator(dirs[i].files);		
		    while(!Files.atEnd())
		    {	
			    File = Files.item();
			    fExt = fsoObj.GetExtensionName(File.Name).toLowerCase();
			    if(fExt == "jpg" || fExt == "gif" || fExt == "bmp" || fExt == "png")
			    {	
				    displayPics[displayPics.length] = File;	
			    }
    		    Files.moveNext();
		    }
	    }
		if (shuffle)
		{
			shuffleDp();
		}
    } 
    else
    {
		MsgPlus.DisplayToast(scriptTitle + " v " + scriptVersionMajor + "." + scriptVersionMinor, "Directory " + DpPath + " does not exist.", "", "displayOptions");		
	}
}

////////////////////////////////////
// Shuffle Display Pictures Array //
////////////////////////////////////
function shuffleDp()
{
	var tmp = new Array();
	while (displayPics.length > 0)
	{
		var i = Math.floor(Math.random()*displayPics.length);
		if (i > displayPics.length - 1) i = displayPics.length - 1;
		tmp[tmp.length] = displayPics.splice(i,1)[0];
	}
	displayPics = tmp;
}

/////////////////
// Start Timer //
/////////////////
function startTimer()
{
	if(aTimer)
	{
		MsgPlus.AddTimer("PDCTimer", timerL);	
	}
}

/////////////////
// Stop Timer //
/////////////////
function stopTimer()
{
	MsgPlus.CancelTimer("PDCTimer");
}

/////////////////
// Event Timer //
/////////////////
function OnEvent_Timer(TimerId)
{
	if(TimerId == "PDCTimer")
	{
		if (aTimer)
		{
			ChangeDp();
		}
		else
		{
			stopTimer();
		}
	}
}

//////////////////////
// Get The Settings //
//////////////////////
function GetSettings(email)
{
	try 
	{			
		DpPath = WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\DpPath');
		subdirs = (WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\subdirs') == "Yes");
		timerL = WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\timerL');
		aLogin = (WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\aLogin') == "Yes");
		aTimer = (WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\aTimer') == "Yes");
		random = (WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\random') == "Yes");
		shuffle = (WScript.RegRead(MsgPlus.ScriptRegPath + email + '\\shuffle') == "Yes");
		if(timerL < 1000 || timerL > 86400000)
		{ 
			timerL = 1800000;
		}
	} 
	catch(exception)
	{
		initOptions();
		SaveSettings(email);
	}
}

///////////////////////
// Save The Settings //
///////////////////////
function SaveSettings(email)
{
	try 
	{
		var tLogin,tTimer,trandom,tshuffle,tsubdirs;
		tsubdirs = (subdirs?"Yes":"No");
		tLogin = (aLogin?"Yes":"No");
		tTimer = (aTimer?"Yes":"No");
		trandom = (random?"Yes":"No");
		tshuffle = (shuffle?"Yes":"No");
		if(timerL < 1000 || timerL > 86400000)
		{
			timerL = 1800000;
		}
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\DpPath', DpPath);
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\subdirs', tsubdirs);
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\aLogin', tLogin);
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\aTimer', tTimer);
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\timerL', timerL);
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\random', trandom);
		WScript.RegWrite(MsgPlus.ScriptRegPath + email + '\\shuffle', tshuffle);				 
	} 
	catch(exception){}
}

/////////////////////
// Version Checker //
/////////////////////
function checkUpdate(warnIfNoUpdate)
{
    var localVersion = parseFloat(scriptVersionMajor + "." + scriptVersionMinor);
	var xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	xmlhttp.open("GET",versionFile,true);
	xmlhttp.send("");
	xmlhttp.onreadystatechange=function()
	{
		if(xmlhttp.readyState==4)
		{
		    if (xmlhttp.status==200)
		    {
			    var resp = xmlhttp.responseText;
			    var serverVersion;
                if (isNaN(resp))
                {
                    serverVersion = parseFloat(resp);
                }
                else
                {
                    serverVersion = resp;
                }
                if (isNaN(serverVersion))
                {
                    MsgPlus.DisplayToast(scriptTitle,"Unable to check for newer version.\nPlease try again later.");
                }
			    else if(serverVersion>localVersion)
			    {
				    //New Version Available
				    MsgPlus.DisplayToast(scriptTitle,"A new version of this script is available.\nClick here to download.","","openDownloadPage");
			    }
			    else if(warnIfNoUpdate)
			    {
			        MsgPlus.DisplayToast(scriptTitle, "No update available\nThe latest version is installed.");
			    }
			}
			else
			{
			    MsgPlus.DisplayToast(scriptTitle,"Unable to check for newer version.\nPlease try again later.");
			}
		}
		else{}
	}
}
function openDownloadPage()
{
	var site = downloadLocation+"?"+(Math.round(Math.random()*99999));
	WScript.run(site);
}